diff --git a/src/core/ngx_flathash.c b/src/core/ngx_flathash.c
new file mode 100644
index 0000000..206036e
--- /dev/null
+++ b/src/core/ngx_flathash.c
@@ -0,0 +1,83 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+
+
+typedef struct {
+    u_char     data[1];
+} ngx_flathash_node_t;
+
+
+#define ngx_flathash_hashsize(n) ((uint32_t)1 << (n))
+#define ngx_flathash_hashmask(n) (ngx_flathash_hashsize(n) - 1)
+#define ngx_flathash_hashfunc(a, b) ngx_lookup3_hashlittle(a, b, 0x715517)
+
+
+/*
+ * Really simple index
+ */
+static inline ngx_flathash_node_t *
+ngx_flathash_index(ngx_flathash_t *hashtable, uint32_t hash) {
+    return (ngx_flathash_node_t *)(hashtable->data +
+                                   ((offsetof(ngx_flathash_node_t, data)
+                                     + hashtable->value_len)
+                                    * hash));
+};
+
+
+void *
+ngx_flathash_get(ngx_flathash_t *hashtable, ngx_str_t *key)
+{
+    uint32_t              hash;
+    ngx_flathash_node_t  *rn;
+
+    hash = ngx_flathash_hashfunc(key->data, key->len)
+	& ngx_flathash_hashmask(hashtable->bits);
+
+    rn = ngx_flathash_index(hashtable, hash);
+
+    return rn->data;
+}
+
+
+size_t
+ngx_flathash_need_memory(size_t length, size_t size)
+{
+    uint32_t    bits;
+    size_t      i;
+
+    for (bits = 0, i = size; i; i >>= 1, bits++);
+
+    bits += 2;
+
+    return offsetof(ngx_flathash_t, data)
+	+ ((offsetof(ngx_flathash_node_t, data)
+	    + length)
+	   * 1<<bits);
+}
+
+
+ngx_int_t
+ngx_flathash_init(ngx_flathash_t *hashtable, size_t length, size_t size)
+{
+    size_t      i;
+
+    hashtable->value_len = length;
+
+    hashtable->bits = 0;
+
+    for (i = size; i; i >>= 1, hashtable->bits++);
+
+    hashtable->bits += 2;
+
+    hashtable->length = 1 << hashtable->bits;
+
+
+    ngx_memzero(hashtable->data, hashtable->length);
+
+    return NGX_OK;
+}
diff --git a/src/core/ngx_flathash.h b/src/core/ngx_flathash.h
new file mode 100644
index 0000000..990018e
--- /dev/null
+++ b/src/core/ngx_flathash.h
@@ -0,0 +1,26 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+#ifndef _NGX_FLATHASH_H_INCLUDED_
+#define _NGX_FLATHASH_H_INCLUDED_
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+
+typedef struct {
+    size_t       value_len;
+    size_t       length;
+    u_char       bits;
+    u_char       data[1];
+} ngx_flathash_t;
+
+void *ngx_flathash_get(ngx_flathash_t *hashtable, ngx_str_t *key);
+
+size_t ngx_flathash_need_memory(size_t length, size_t size);
+
+ngx_int_t ngx_flathash_init(ngx_flathash_t *hashtable, size_t length, size_t size);
+
+
+#endif /* _NGX_FLATHASH_H_INCLUDED_ */
diff --git a/src/core/ngx_log.c b/src/core/ngx_log.c
index 770a590..eed1d87 100644
--- a/src/core/ngx_log.c
+++ b/src/core/ngx_log.c
@@ -139,7 +139,11 @@ ngx_log_error_core(ngx_uint_t level, ngx_log_t *log, ngx_err_t err,
 
     ngx_linefeed(p);
 
-    (void) ngx_write_fd(log->file->fd, errstr, p - errstr);
+    if ((!log->last_write_log_time ||
+	 ngx_time() - log->last_write_log_time > log->write_retry_period)
+	&& ngx_write_fd(log->file->fd, errstr, p - errstr) == -1) {
+        log->last_write_log_time = ngx_time();
+    }
 
     if (!ngx_use_stderr
         || level > NGX_LOG_WARN
@@ -428,6 +432,9 @@ ngx_error_log(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
 
     value = cf->args->elts;
 
+    cf->cycle->new_log.last_write_log_time = 0;
+    cf->cycle->new_log.write_retry_period = NGX_ERROR;
+
     if (ngx_strcmp(value[1].data, "stderr") == 0) {
         name.len = 0;
         name.data = NULL;
@@ -441,8 +448,16 @@ ngx_error_log(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
         return NULL;
     }
 
-    if (cf->args->nelts == 2) {
+    if (cf->args->nelts > 2) {
         cf->cycle->new_log.log_level = NGX_LOG_ERR;
+        cf->cycle->new_log.write_retry_period = ngx_atoi(value[1].data, value[1].len);
+    }
+
+    if (cf->cycle->new_log.write_retry_period == NGX_ERROR) {
+	cf->cycle->new_log.write_retry_period = 30;
+    }
+
+    if (cf->cycle->new_log.log_level == NGX_LOG_ERR) {
         return NGX_CONF_OK;
     }
 
diff --git a/src/core/ngx_log.h b/src/core/ngx_log.h
index b736aa2..ae4d71c 100644
--- a/src/core/ngx_log.h
+++ b/src/core/ngx_log.h
@@ -60,6 +60,9 @@ struct ngx_log_s {
      */
 
     char                *action;
+
+    time_t               last_write_log_time;
+    ngx_int_t            write_retry_period;
 };
 
 
